* PACKAGE DLPFRG    !" ʬ( Leap Frog Scheme )
*
*"  [HIS] 92/01/09 (momoko)
*"        95/08/14 (takepiro) 
***********************************************************************
      SUBROUTINE DLPFRG
     O             ( PSI3  , ZETA3 , T3  ,
     I               PSI2  , ZETA2 , T2  , 
     I               PSI1  , ZETA1 , T1  , 
     I               RAYL  , PRND  , QINT,
     C               DX    , DZ    , DT  ,
     W               AJAC  , ALAP   ) 
*
*"       << Leapfrog scheme ˤ꼡ƥåפʪ̤׻ >>
*"                                      92/01/13 ()
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL T3    ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL PSI1  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(2STEP)
      REAL ZETA1 ( 0:NX+1 , 0:NZ+1 ) !" (2STEP)
      REAL T1    ( 0:NX+1 , 0:NZ+1 ) !" (2STEP)
*
      REAL PRND                 !" ץȥ
      REAL RAYL                 !" 쥤꡼
      REAL QINT                 !" ǮΨ
*
      REAL DX                   !" X γʻֳ
      REAL DZ                   !" Z γʻֳ
      REAL DT                   !" ֳִ
*
* [WORK]
      REAL AJAC ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
      LOGICAL OFIRST
      DATA    OFIRST  / .TRUE. /
*    
      SAVE  OFIRST 
*
      IF( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL MSGDMP('M','DLPFRG',
     &               'LEAPFROG SCHEME TIME INTEGRATE : 95/08/14' )
      ENDIF
*
*"        < 1. ΰα٤η׻ >
*
      CALL DLPFZ
     O      ( ZETA3 , 
     I        PSI2  , ZETA2 , T2  , 
     I        ZETA1 , 
     C        RAYL  , PRND  ,
     C        DX    , DZ    , DT  ,
     W        AJAC  , ALAP   )
*
*"        < 2. ΰβ٤η׻ >
*
      CALL DLPFT
     O      ( T3    , 
     I        PSI2  , T2    , 
     I        T1    , 
     C        QINT  , 
     C        DX    , DZ    , DT  ,
     W        AJAC  , ALAP    )
*
*"        < 3. ŬѤήؿη׻ >
*
      CALL DBNDR
     O       ( PSI3  , 
     M         ZETA3 , T3   ,
     I         DX    , DZ    )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE DLPFZ     !" Leapfrog Scheme ˤ뱲
     O             ( ZETA3 , 
     I               PSI2  , ZETA2 , T2  , 
     I               ZETA1 , 
     C               RAYL  , PRND  ,
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP1   )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !"(STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !"ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !"(1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !"(1STEP)
      REAL ZETA1 ( 0:NX+1 , 0:NZ+1 ) !"(2STEP)
*
      REAL PRND                      !"ץȥ
      REAL RAYL                      !"쥤꡼
      REAL DX                        !"Xγʻֳ
      REAL DZ                        !"Zγʻֳ
      REAL DT                        !"ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP1 ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !"롼ץ
      INTEGER IZ                   !"롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC2,
     I         PSI2 , ZETA2,
     D         DX   , DZ    )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP1,
     I         ZETA1,
     C         DX   , DZ   )
*
*"        < 3. ƥåɤα٤ͤη׻ >
*
      DO 3020 IZ = 1 , NZ
        DO 3020 IX = 1 , NX
              ZETA3( IX,IZ ) 
     &    =   ZETA1( IX,IZ )
     &      + 2.0D0*DT
     &        *(   AJAC2(IX,IZ) + PRND*ALAP1(IX,IZ)
     &           - PRND*RAYL*( T2(IX+1,IZ) - T2(IX-1,IZ) )/(2.0D0*DX)
     &         )
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DLPFT     !" Leapfrog Scheme ˤ벹
     O             ( T3    , 
     I               PSI2  , T2    , 
     I               T1    , 
     C               QINT  , 
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP1   )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL T3 ( 0:NX+1 , 0:NZ+1 )    !" (STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T1    ( 0:NX+1 , 0:NZ+1 ) !" (2STEP)
*
      REAL QINT                      !" ǮΨ
*
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
      REAL DT                        !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1 , 0:NZ+1 ) !" 䥳ӥ
      REAL ALAP1 ( 0:NX+1 , 0:NZ+1 ) !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC2,
     I         PSI2 , T2  ,
     C         DX   , DZ   )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP1,
     I         T1   ,
     C         DX   , DZ   )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      DO 3020 IX = 1 , NX
        DO 3010 IZ = 1 , NZ
              T3(IX,IZ) 
     &    =   T1(IX,IZ)
     &      + 2.0D0*DT
     &        *( AJAC2(IX,IZ) + ALAP1(IX,IZ) + QINT )
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END
